import { NodeModuleInfo, DependencyTree } from "./types";
export declare abstract class NodeModulesCollector {
    private readonly rootDir;
    private nodeModules;
    protected dependencyPathMap: Map<string, string>;
    protected allDependencies: Map<string, DependencyTree>;
    constructor(rootDir: string);
    private transToHoisterTree;
    protected resolvePath(filePath: string): string;
    private convertToDependencyGraph;
    getAllDependencies(tree: DependencyTree): void;
    abstract getCommand(): string;
    abstract getArgs(): string[];
    abstract removeNonProductionDependencie(tree: DependencyTree): void;
    protected getDependenciesTree(): Promise<DependencyTree>;
    private _getNodeModules;
    private getTreeFromWorkspaces;
    getNodeModules(): Promise<NodeModuleInfo[]>;
}
