"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PnpmNodeModulesCollector = void 0;
const nodeModulesCollector_1 = require("./nodeModulesCollector");
const path = require("path");
class PnpmNodeModulesCollector extends nodeModulesCollector_1.NodeModulesCollector {
    constructor(rootDir) {
        super(rootDir);
    }
    getCommand() {
        return process.platform === "win32" ? "pnpm.cmd" : "pnpm";
    }
    getArgs() {
        return ["list", "--prod", "--json", "--depth", "Infinity"];
    }
    removeNonProductionDependencie(tree) {
        const dependencies = tree.dependencies || {};
        const p = path.normalize(this.resolvePath(tree.path));
        const pJson = require(path.join(p, "package.json"));
        const _dependencies = pJson.dependencies || {};
        const _optionalDependencies = pJson.optionalDependencies || {};
        const prodDependencies = { ..._dependencies, ..._optionalDependencies };
        for (const [key, value] of Object.entries(dependencies)) {
            if (!prodDependencies[key]) {
                delete dependencies[key];
                continue;
            }
            this.removeNonProductionDependencie(value);
        }
    }
}
exports.PnpmNodeModulesCollector = PnpmNodeModulesCollector;
//# sourceMappingURL=pnpmNodeModulesCollector.js.map