"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YarnNodeModulesCollector = void 0;
const nodeModulesCollector_1 = require("./nodeModulesCollector");
class YarnNodeModulesCollector extends nodeModulesCollector_1.NodeModulesCollector {
    constructor(rootDir) {
        super(rootDir);
    }
    getCommand() {
        return process.platform === "win32" ? "npm.cmd" : "npm";
    }
    getArgs() {
        return ["list", "-a", "--include", "prod", "--include", "optional", "--omit", "dev", "--json", "--long", "--silent"];
    }
    removeNonProductionDependencie(tree) {
        var _a;
        const dependencies = tree.dependencies || {};
        const _dependencies = tree._dependencies || {};
        if (dependencies && Object.keys(dependencies).length === 0) {
            tree.dependencies = ((_a = this.allDependencies.get(`${tree.name}@${tree.version}`)) === null || _a === void 0 ? void 0 : _a.dependencies) || {};
        }
        for (const [key, value] of Object.entries(dependencies)) {
            if (!_dependencies[key] || Object.keys(value).length === 0) {
                delete dependencies[key];
                continue;
            }
            this.removeNonProductionDependencie(value);
        }
    }
}
exports.YarnNodeModulesCollector = YarnNodeModulesCollector;
//# sourceMappingURL=yarnNodeModulesCollector.js.map